﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Windows;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Serialize;
using ThinkGeo.MapSuite.Shapes;
using System.Windows.Controls;
using System.Windows.Media.Imaging;
using System.Windows.Input;
using System.Runtime.CompilerServices;
using ThinkGeoGis.Helper;
using System.Reflection;

namespace ThinkGeoGis.GisCore
{

    public class OwnEllipse : ContentControl
    {
        public Ellipse ellipse;
        public OwnEllipse()
        {
            ellipse = new Ellipse();
            ellipse.Stroke = Brushes.Blue;
            ellipse.StrokeThickness = 0;
            ellipse.Stretch = Stretch.Fill;
            //ellipse.Fill = Brushes.YellowGreen;
            Color color = Colors.Yellow;
            ellipse.Fill = new RadialGradientBrush(new GradientStopCollection()
            {
                new GradientStop(Color.FromScRgb(0,color.R,color.G,color.B), 1),
                new GradientStop(Color.FromScRgb((float)0.4,color.R,color.G,color.B), .5),
                new GradientStop(Color.FromScRgb((float)0.7,color.R,color.G,color.B), .7),
                new GradientStop(Color.FromScRgb((float)0.8,color.R,color.G,color.B), .8),
                new GradientStop(Color.FromScRgb((float)0.9,color.R,color.G,color.B), .9),
                new GradientStop(Color.FromScRgb((float)1,color.R,color.G,color.B), 1),
            });
            ellipse.Width = 15;
            ellipse.Height = 15;
            Width = ellipse.Width;
            Height = ellipse.Height;
            this.ellipse.ToolTip = "show tooltip test";
            this.ellipse.MouseDown += Ellipse_MouseDown;
            this.Content = ellipse;
            
            this.IsHitTestVisible = true;
        }

        private void Ellipse_MouseDown(object sender, MouseButtonEventArgs e)
        {
            MessageBox.Show("this points is clicked");
        }
    }


    [DesignTimeVisible(false), ToolboxItem(false), NonSerializableBaseType]
    [Serializable]
    public class GisPoint
    {
        public PointShape pointshape;

        public OwnEllipse ellipse;
        public GisPoint(PointShape ptshape)
        {
            ellipse = new OwnEllipse();
            pointshape = ptshape;
        }

        public void Draw(RectangleShape targetExtent, double drawingScreenWidth, double drawingScreenHeight)
        {
            ScreenPointF point = ExtentHelper.ToScreenCoordinate(targetExtent, pointshape, (float)drawingScreenWidth, (float)drawingScreenHeight);
            Point pt = new Point(point.X,point.Y);
            Canvas.SetLeft(ellipse, pt.X - ellipse.Width/2);
            Canvas.SetTop(ellipse, pt.Y - ellipse.Height/2);
        }
    }
}
